Index: branches/reconfiguration/modules/dspin_router/caba/test/recovery_bcast_evaluation/dspin_broadcast_generator/caba/source/src/dspin_broadcast_generator.cpp
===================================================================
--- branches/reconfiguration/modules/dspin_router/caba/test/recovery_bcast_evaluation/dspin_broadcast_generator/caba/source/src/dspin_broadcast_generator.cpp	(revision 1009)
+++ branches/reconfiguration/modules/dspin_router/caba/test/recovery_bcast_evaluation/dspin_broadcast_generator/caba/source/src/dspin_broadcast_generator.cpp	(revision 1016)
@@ -1,24 +1,24 @@
 /* -*- c++ -*-
  * SOCLIB_LGPL_HEADER_BEGIN
- * 
+ *
  * This file is part of SoCLib, GNU LGPLv2.1.
- * 
+ *
  * SoCLib is free software; you can redistribute it and/or modify it
  * under the terms of the GNU Lesser General Public License as published
  * by the Free Software Foundation; version 2.1 of the License.
- * 
+ *
  * SoCLib is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  * Lesser General Public License for more details.
- * 
+ *
  * You should have received a copy of the GNU Lesser General Public
  * License along with SoCLib; if not, write to the Free Software
  * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
  * 02110-1301 USA
- * 
+ *
  * SOCLIB_LGPL_HEADER_END
  *
- * Authors  : alain.greiner@lip6.fr 
+ * Authors  : alain.greiner@lip6.fr
  * Date     : july 2010
  * Copyright: UPMC - LIP6
@@ -44,9 +44,9 @@
                                      const size_t   x_size,
                                      const size_t   y_size,
-                                     const size_t   srcid,      // srcid for random 
+                                     const size_t   srcid,      // srcid for random
                                      const size_t   load,       // requested load * 1000
                                      const size_t   fifo_depth) // Fifo depth
            : BaseModule(name),
-           
+
            p_clk( "clk" ),
            p_resetn( "resetn" ),
@@ -58,5 +58,5 @@
 
            r_send_fsm( "r_send_fsm" ),
-           r_send_length( "r_send_length" ), 
+           r_send_length( "r_send_length" ),
            r_send_dest( "r_send_dest" ),
            r_send_date( "r_send_date" ),
@@ -69,5 +69,5 @@
 
            r_max_fill_status( "r_max_fill_status" ),
-           
+
            r_date_fifo( "r_date_fifo", fifo_depth ),
 
@@ -127,5 +127,5 @@
 
     /////////////////////////// CMD FSM
-    switch( r_send_fsm.read() ) 
+    switch( r_send_fsm.read() )
     {
         case SEND_IDLE:
@@ -141,5 +141,5 @@
         break;
         case SEND_BROADCAST:
-            if( p_out.read.read() ) 
+            if( p_out.read.read() )
             {
                 r_send_length = r_send_length.read() - 1;
@@ -164,5 +164,5 @@
             if (latency > r_receive_bc_max_latency.read())
                 r_receive_bc_max_latency = latency;
-            
+
             r_receive_fsm = RECEIVE_IDLE;
         }
@@ -178,5 +178,5 @@
     if (r_date_fifo.filled_status() > r_max_fill_status.read())
         r_max_fill_status.write(r_date_fifo.filled_status());
-    
+
 } // end transition
 
@@ -210,5 +210,5 @@
     p_out.eop   = eop;
     p_out.write = write;
-    
+
     p_in.read = true;
 
@@ -221,7 +221,7 @@
     const char* rsp_str[] = { "IDLE", "RECEIVE_BROADCAST" };
 
-    std::cout << "DSPIN_GENERATOR " << name() 
-              << " : send_fsm = " << cmd_str[r_send_fsm.read()] 
-              << " / recv_fsm = " << rsp_str[r_receive_fsm.read()] 
+    std::cout << "DSPIN_GENERATOR " << name()
+              << " : send_fsm = " << cmd_str[r_send_fsm.read()]
+              << " / recv_fsm = " << rsp_str[r_receive_fsm.read()]
               << " / fifo_content = " << r_date_fifo.filled_status() << std::endl;
 } // end print_trace
@@ -253,2 +253,4 @@
 // indent-tabs-mode: nil
 // End:
+
+// vim: ts=4 : sts=4 : sw=4 : et